/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2018 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
 
package org.ow2.easywsdl.extensions.multiple.impl;

import org.ow2.easywsdl.extensions.multiple.api.Description;
import org.ow2.easywsdl.extensions.multiple.api.MultipleExtException;
import org.ow2.easywsdl.wsdl.ExtensionFactory;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfDescription;
import org.ow2.easywsdl.wsdl.decorator.DecoratorDescriptionImpl;

/**
 * @author Nicolas Boissel-Dallier - EBM WebSourcing
 */
public class DescriptionImpl<D extends AbsItfDescription> extends DecoratorDescriptionImpl implements Description {

	public DescriptionImpl(final AbsItfDescription wsdl) throws WSDLException {
		super(wsdl, null);
	}


	public <D extends AbsItfDescription> D find(ExtensionFactory factory) throws MultipleExtException {
		
		AbsItfDescription temp = this;
		Class descClass = factory.getDescriptionType();
		D res = null;

		while(temp instanceof DecoratorDescriptionImpl && res == null){
			if(descClass.isInstance(temp)){
				res = (D)temp;
			} else {
				temp = (AbsItfDescription)((DecoratorDescriptionImpl)temp).getInternalObject();
			}
		}
		
		if(res == null && temp instanceof org.ow2.easywsdl.wsdl.api.Description){
			try {
				res = (D) factory.addExtElmt2Description(this);
			} catch (WSDLException e) {
				throw new MultipleExtException(e);
			}
		}
		
		return res;
	}
	

}
